//
//  v002RuttEtraPlugIn.h
//  v002RuttEtra
//
//  Created by vade on 9/23/08.
//  Copyright (c) 2008 vade/Bill Etra. All rights reserved.
//
//  Heightfield_gtplugin.h Created by George Toledo 2/15/10


#import <Quartz/Quartz.h>
#import "gtShader.h"

@interface Heightfield_gtPlugIn : QCPlugIn
{
	int kSizeX, kSizeY;
	
	gtShader* heightMapShader;
	gtShader* normalShader;
	gtShader* normalShaderHQ;
	
	// do we have support for ARB_texture_float?
	
	BOOL supportsFloatTextures;
	
	GLuint quadDL; // display list

	GLuint* scanLineIndices;
	GLuint* meshIndices;
	
	//GLuint _renderBuffer, _frameBuffer, _vertexBuffer, _vertexBufferForNormals, _vertexBufferForTexCoords;
	GLuint _renderBuffer, _textureAttachment0,_textureAttachment1, _frameBuffer, _vertexBuffer, _vertexBufferForNormals, _vertexBufferForTexCoords;
	
	// GL State
	GLint previousFBO;
	GLint previousReadFBO; // for 10.6
	GLint previousDrawFBO; // for 10.6
	GLint previousBufferBinding;
	GLint oldFactor;
	GLint oldPattern;
	GLint previousShader;
//	GLint previousTexture;		// attempt at restoring shader bound textures...
//	GLint previousTextureType;
//	GLint previousTextureUnit;
}

@property (assign) id<QCPlugInInputImageSource> inputImage;						// input images
@property (assign) id<QCPlugInInputImageSource> inputImageLuma;	
@property (assign) double		inputWireFrameWidth;
@property (assign) NSUInteger	inputDrawType;
@property (assign) double		inputDepthScale;
@property (assign) double		inputResolutionX;
@property (assign) double		inputResolutionY;
@property (assign) double		inputRepeatCount;
@property (assign) double		inputStipplePattern;
@property (assign) BOOL			inputAntialias;
@property (assign) BOOL			inputCalculateNormals;
@property (assign) double		inputNormalCoeff;
@property (assign) BOOL			inputHQNormals;
@property double inputX;
@property double inputY;
@property double inputZ;
@property double inputRotationX;
@property double inputRotationY;
@property double inputRotationZ;
@property (assign) NSUInteger inputBlendMode; 
@property (assign) NSUInteger inputDepthMode;
@property (assign) NSUInteger inputCulling;


@end
